%---- file name: aut_clos_req.ec ----

% this is the set of actions which must be executed
% when a shunting route mechanism requests the 
% automatic closure of the level crossing


parse aut_clos_req =
let rec {
  % waiting the command start_close_aut"
  
  S = start_close_aut? : A

and
  % tests the value of the variable "command_state"
  % in the case of value different from automatic, the command is lost
  % and the new state is S 

  A = manual? : H +
      break_opening? : S +
      automatic? : B

and
  % tests the value of the variable "lcc_state" 

  B = wait_the_timer? : H +
      closure_req? : H +
      open_req? : C +
      doing_open? : C +
      open_done? : C +
      lcc_idle? : D
and
   % sets the value of "command_state" to "closed"

   C = s_break_opening! : H

and 
   % the value of "lcc_state" is "idle". 
   % The variable is then set to "wait_the_timer" 

   D = s_wait_the_timer! : H

and 

  H = end! :S 
} in S;

%---- end of file aut_clos_req.ec ----
